#!/usr/bin/env python3
""" Statistical Language processing, Assignment 5
	See <https://snlp2021.github.io/a5/> for detailed instructions.

	<Please insert your name and the honor code here.>
"""

def read_data(filename):
	"""Read a simple word list and create two sequences, one with
	   words without space segmentation, another with labels that
	   indicates points of hyphenation.

	Parameters:
	-----------
	filename:    The name of the file to read from.

	Return value: two sequences (of sequences), one containing
				  the unsegmented words, the other corresponding
				  to label sequences.
	"""
	### Exercise 5.1

class Encoder:
	""" A class to encode words and their label sequences.

		Overall, we follow an sklearn-like API. The method fit()
		performs necessary book keeping actions given a word list,
		and transform() turns both words and their labels to numpy
		arrays ready to be used by the neural network.

	"""
	### Exercise 5.2
	def __init__(self):
		""" The constructor.

		You are not required to implement anything here. Feel free to
		initialize some of the data structures you use here.

		"""
		### Exercise 5.2

	def fit(self, words, maxlen=0):
		"""Given the sequence of words, perform necessary book keeping.

		Typically, you will want to keep a mapping from letters to
		integers. You are also required to reserve integers for three
		special 'symbols': beginning of word, end of word and unknown
		letters. The integer 0 should be reserved for padding and
		should not be used otherwise. You should assign consecutive
		integer values for the symbols (letters and special symbols)
		starting from 0 (for padding). For example, do not use 'ord()'
		to obtain a sparse encoding (unused integers increase the
		number of parameters in our network).

		Parameters:
		-----------
		words:      A sequence of words to train the encoder on.
		maxlen:     Maximum word length. If not 0, all shorter words
					should be padded and longer words truncated to
					this length. If unspecified (or 0), then maxlen
					should be set to the maximum word length in the
					given sequence.

		Return value: None
		"""
		### Exercise 5.2

	def transform(self, words, labels=None):
		"""Encode given words and labels.

		This method encodes words as a 2D numpy array with shape (n,
		maxlen + 2), and the labels (if given) a 3D numpy array (n,
		maxlen + 2, 1).  This particular data format is required
		because of the way we construct our neural network. For
		encoded words, each cell should contain an integer code for
		each symbol as determined in the fit() method. For labels, use
		1 for 'B' and '0' for 'I' and other special symbols.

		The maximum time steps (length of words) should be set to
		'maxlen' parameter of the fit() method (you should save it as
		an instance variable in fit()) plus 2. The '+2' part in the
		sequence length comes from the beginning- and end-of-word
		symbols.

		Parameters:
		-----------
		words:      A sequence of words to be encoded.
		labels:     An optional sequence of labels, if given should
					also be encoded.

		Return value: A tuple: encoded words and labels (or None if
					  not given).
		"""
		### Exercise 5.2

def train_rnn(x, y):
	"""Define and train an RNN that predicts the segmentation points.

	Your RNN should predict a label for each character in the input.
	You are asked (for simplicity) to implement a simple network (5.3)
	and improve over it later (5.4). You do not need to keep the
	version of the network from the first stage.

	Parameters:
	-----------
	x:      Encoded input, a two-dimensional numpy array with shape
			(n_instances, n_time_steps).
	y:      Encoded labels, a three-dimensional numpy array with shape
			(n_instances, n_time_steps, 1).

	Return value: The trained Keras model instance.
	"""
	### Exercise 5.3
	### Exercise 5.5

def hyphenate(model, encoder, words):
	"""Hyphenate the given words using the trained model.

	Parameters:
	-----------
	model:      A trained network.
	encoder:    A trained encoder instance.
	words:      A sequence of words.

	Return value: Hyphenated words (same as words with spaces at
				  the possible hyphenation points)
	"""
	### Exercise 5.3

def evaluate(gold, pred, positive_class='B'):
	"""Evaluate the given segmentation against the gold standard labels.

	Parameters:
	-----------
	gold:   Gold standard labels: a sequence of sequences (strings)
			representing the true B/I labels.
	pred:   Models prediction of probabilities of each label.

	Return value: (precision, recall, f1-score)
	"""
	### Exercise 5.4

if __name__ == "__main__":
	### Not required, but example usage can go in here.
